<template>
    <div class="users-page" v-if="hasToken">
        <component v-show="listingShowed" :is="currentUserComponent" :key="rerenderKey" @data:loaded="showList"/>
    </div>
</template>

<script>
import { filterQuery } from '@bloomio/spa-admin-common/utils';
import {
    UsersListing as users, InvestorsListing as investors, StartupsListing as startups,
    SubscribersListing as subscribers,
} from '@/components/Listing';

/**
 * Base Layout component for all user listings
 */
export default {
    components: {
        users,
        investors,
        startups,
        subscribers,
    },
    data() {
        return {
            listingShowed: false,
        };
    },
    watch: {
        $route: {
            handler(newVal, oldVal) {
                if (newVal.name === 'subscribers' && (!oldVal || newVal.name !== oldVal.name)) {
                    this.$store.dispatch('subscribers/getFilterDictionary');
                }
            },
            immediate: true,
        },
    },
    computed: {
        currentUserComponent: vm => vm.$route.name,
        hasToken: vm => vm.$store.getters.token,
        rerenderKey: vm => vm.$route.name + filterQuery(vm.$route.query), // redraw listing if route is changed
    },
    methods: {
        /**
         * Event handler for dynamic listing component.
         * Shows listing only when data was uploaded from server.
         */
        showList() {
            this.listingShowed = true;
        },
    },
};
</script>

<style lang="stylus">
.page_settings
    display: flex
    justify-content: space-between
    align-items: center
    margin-bottom: 2rem

</style>
